(*)--[ Pascal Support ]-------------------------------------------------------
   ࠪ⠫쭮 ॢ.
            by Victor Shantar (2:5054/26@FidoNet)
---------------------------------------------------------------------------(*)
Program Fractal_Tree;

Uses Graph,Crt;

const   max   =  26000;
Type    mas   =  ^arr;
        arr   =  array [1..max] of char;
        prec  =  ^rec;
        rec   =  record
                 x,y:integer;
                 next:prec
                 end;


Const   n     =  8;
        x0    : integer =  320;
        y0    : integer =  480;
        len   =  3;

Var     m                        :  mas;
        i                        :  word;
        k                        :  word;
        top                      :  prec;
        angle                    :  real;
        key                      :  char;
        s                        : shortint;

Procedure Init;
Var driver,mode:integer;
Begin
  driver:=detect;
  initgraph(driver,mode,'');
  getmem(m,max);
  m^[1]:='0';
  m^[2]:='0';
  k:=1;
  angle:=0;s:=1;
  randomize;
  new(top);
  top^.x:=x0;
  top^.y:=y0;
  top^.next:=nil;
    setcolor(10);
    setbkcolor(black);
    setfillstyle(solidfill,0);
    cleardevice;
    outtextxy(1,1,' 㣠.,   - ᥣ  ᪮ ॢ.');
    outtextxy(1,12,' ESC  室     ᫥饣 ॢ.');
End;

Procedure Push(var p:prec;x1,y1:integer);
Var r:prec;
Begin
  new(r);
  with r^ do begin
             x:=x1;
             y:=y1;
             next:=p
             end;
  p:=r;

End;

Procedure Pop(var p:prec;var x1,y1:integer);
Var r:prec;
Begin
  if p<>nil then begin
                 x1:=p^.x;
                 y1:=p^.y;
                 r:=p;
                 p:=p^.next;
                 dispose(r)
                 end;
End;

Procedure GetTree;
Const cs:string='1[0]1[0]0';
Var k2:mas;
    i,j,z:word;
    one:boolean;
Begin
  getmem(k2,max);
  one:=false;
  i:=1;j:=1;
  while i<=k do begin
                case m^[i] of
                '0': begin
                     for z:=1 to 9 do k2^[z+j-1]:=cs[z];
                     j:=j+9
                     end;
                '1': begin
                     k2^[j]:='1';
                     inc(j);
                     if one or (i<3) then begin
                     k2^[j]:='1';
                     inc(j)      end;
                     one:=not one;
                     end;
                '[': begin k2^[j]:='[';inc(j) end;
                ']': begin k2^[j]:=']';inc(j) end
                end;  { ..of case }
                inc(i)
                end;
  m^:=k2^;
  freemem(k2,max);
  k:=j-1
End;

Procedure DrawTree(a:real);
var   b            :  boolean;

Begin
  b:=false;
  angle:=angle+a;
  repeat
  inc(i);
  case m^[i] of
   '1' : begin
          if getcolor<>6 then setcolor(6);
          line(x0,y0,x0+trunc(len*sin(angle)),y0-trunc(len*cos(angle)));
          dec(y0,trunc(len*cos(angle)));
          inc(x0,trunc(len*sin(angle)))
         end;

   '0' : begin
          if getcolor<>green then setcolor(green);
          line(x0,y0,x0+trunc(len*sin(angle)),y0-trunc(len*cos(angle)));
          dec(y0,trunc(len*cos(angle)));
          inc(x0,trunc(len*sin(angle)));
          circle(x0,y0,1)
         end;

   '[' : begin
          push(top,x0,y0);
          s:=s*(-1);
          drawtree((random*pi/6+pi/20)*s);{sgn(random-0.5))}
         end;

   ']' : begin
          pop(top,x0,y0);
          b:=true
         end;
   end;
   until (i>(k+1))or b;
   angle:=angle-a
End;

Procedure Done;
begin
 freemem(m,max);
 closegraph
end;

Begin
 Init;
 for i:=1 to n do GetTree;
 repeat
 i:=0;
 DrawTree(0);
 key:=readkey;
 cleardevice;
 x0:=320;y0:=480;
 until key=#27;
 Done
End.
